Description

The Foreman::Controller::SmartProxyAuth attempts to use smart proxy certificate authentication by looking for client certificates. It

does so by looking at the ssl_client_cert_env setting. In a reverse proxy setup (Apache from EL7) with a standalone Foreman

process (using Puma) I set the following in /etc/foreman/settings.yaml:

# Configure reverse proxy headers

:ssl_client_dn_env: HTTP_SSL_CLIENT_S_DN

:ssl_client_verify_env: HTTP_SSL_CLIENT_VERIFY

:ssl_client_cert_env: HTTP_SSL_CLIENT_CERT

 When you navigate to a page with a browser that doesn't present any certificates but is authenticated, the result is that

request.env[Setting[:ssl_client_cert_env]] returns (none). The code then attempts to parse this as a certificate which obviously fails.

Associated revisions

Revision fa571deb - 04/18/2019 09:33 AM - Ewoud Kohl van Wijngaarden

Fixes #26634 - Handle (none) certificates in SmartProxyAuth

When visiting the page from behind a reverse proxy this value can end up

as (none) and then fails to parse. This special cases it.

History

#1 - 04/17/2019 12:45 PM - The Foreman Bot

- Status changed from New to Ready For Testing

- Assignee set to Ewoud Kohl van Wijngaarden

- Pull request https://github.com/theforeman/foreman/pull/6691 added

#2 - 04/17/2019 01:02 PM - Ewoud Kohl van Wijngaarden

- Subject changed from Smart proxy auth concern doesn't handle reverse proxy setup when the cert is (none) to Smart proxy auth concern doesn't

handle reverse proxy setup when the cert is (null)

#3 - 04/18/2019 09:33 AM - Tomer Brisker

- Fixed in Releases 1.22.0 added

#4 - 04/18/2019 10:01 AM - Ewoud Kohl van Wijngaarden

- Status changed from Ready For Testing to Closed

Applied in changeset fa571deb45e7f9a4a438c83585a3bfbfcfeec58b.
